﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using connector = Microsoft.Office.Server.Search.Connector;
using Microsoft.Office.Server.Search.Connector.BDC;
using Microsoft.BusinessData.MetadataModel;
using Microsoft.BusinessData.Runtime;

namespace XmlFileConnector
{
    /// <summary>
    /// This class defines functions that return the URL of the 
    /// entity instance to the search system
    /// </summary>
    class XmlDocumentNamingContainer : INamingContainer
    {
        #region INamingContainer Members

        private Uri sourceUri;
        private Uri accessUri;

        //GUID of the property set for the connector
        private static Guid propertySetGuid = new Guid("{BCC9619B-BFBD-4BD6-8E51-466F9241A27A}");
        
        public void Initialize(Uri uri)
        {
            this.sourceUri = uri;
        }
                        
        public Uri GetAccessUri(ILobSystem lobSystem)
        {
            throw new NotSupportedException();
        }

        public Uri GetDisplayUri(ILobSystem lobSystem)
        {
            return null;
        }

        public Uri GetAccessUri(ILobSystemInstance lobSystemInstance)
        {
            throw new NotSupportedException();
        }

        public Uri GetDisplayUri(ILobSystemInstance lobSystemInstance)
        {
            return this.sourceUri;
        }

        public Uri GetAccessUri(IEntity entity, ILobSystemInstance lobSystemInstance)
        {
            throw new NotSupportedException();
        }

        public Uri GetDisplayUri(IEntity entity, ILobSystemInstance lobSystemInstance)
        {
            throw new NotSupportedException();
        }

        public Uri GetAccessUri(IEntityInstance entityInstance)
        {
            object[] ids = entityInstance.GetIdentity().GetIdentifierValues();
            string idString = ids[0].ToString();
            this.accessUri = new Uri(this.sourceUri + "/" + idString);
            return this.accessUri;
        }
        
        public Uri GetDisplayUri(IEntityInstance entityInstance, IEntityInstance parentEntityInstance)
        {
            return null;
        }

        public Uri GetAccessUri(IEntityInstance entityInstance, IEntityInstance parentEntityInstance)
        {
            return this.GetAccessUri(entityInstance);
        }

        public Uri GetDisplayUri(IEntityInstance entityInstance, string computedDisplayUri)
        {
            if (string.IsNullOrEmpty(computedDisplayUri))
                return this.sourceUri;
            return new Uri(computedDisplayUri);
        }
                                       
        public Guid PartitionId
        {
            get { return Guid.Empty; }
        }

        public Guid PropertySet
        {
            get { return propertySetGuid; }
        }
        #endregion
    }
}
